package stastro

import (
	"math"

	"gitlab.com/solsw/TurboPower/SysTools/internal/common"
)

func _GetLongitudeMars(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	L0 := 6.20347711580 * math.Cos(0.00000000000+0.00000000000*Tau)
	L0 += 0.18656368100 * math.Cos(5.05037100300+3340.61242670000*Tau)
	L0 += 0.01108216792 * math.Cos(5.40099836960+6681.22485340000*Tau)
	L0 += 0.00091798394 * math.Cos(5.75478745110+10021.83728000000*Tau)
	L0 += 0.00027744987 * math.Cos(5.97049512940+3.52311834900*Tau)
	L0 += 0.00012315897 * math.Cos(0.84956081238+2810.92146160000*Tau)
	L0 += 0.00010610230 * math.Cos(2.93958524970+2281.23049650000*Tau)
	L0 += 0.00008926772 * math.Cos(4.15697845940+0.01725365220*Tau)
	L0 += 0.00008715688 * math.Cos(6.11005159790+13362.44970700000*Tau)
	L0 += 0.00007774867 * math.Cos(3.33968655070+5621.84292320000*Tau)
	L0 += 0.00006797552 * math.Cos(0.36462243626+398.14900341000*Tau)
	L0 += 0.00004161101 * math.Cos(0.22814975330+2942.46342330000*Tau)
	L0 += 0.00003575079 * math.Cos(1.66186540140+2544.31441990000*Tau)
	L0 += 0.00003075250 * math.Cos(0.85696597082+191.44826611000*Tau)
	L0 += 0.00002937543 * math.Cos(6.07893711410+0.06731030280*Tau)
	L0 += 0.00002628122 * math.Cos(0.64806143570+3337.08930840000*Tau)
	L0 += 0.00002579842 * math.Cos(0.02996706197+3344.13554500000*Tau)
	L0 += 0.00002389420 * math.Cos(5.03896401350+796.29800682000*Tau)
	L0 += 0.00001798808 * math.Cos(0.65634026844+529.69096509000*Tau)
	L0 += 0.00001546408 * math.Cos(2.91579633390+1751.53953140000*Tau)
	L0 += 0.00001528140 * math.Cos(1.14979306230+6151.53388830000*Tau)
	L0 += 0.00001286232 * math.Cos(3.06795924630+2146.16541650000*Tau)
	L0 += 0.00001264356 * math.Cos(3.62275092230+5092.15195810000*Tau)
	L0 += 0.00001024907 * math.Cos(3.69334293550+8962.45534990000*Tau)
	L0 += 0.00000891567 * math.Cos(0.18293899090+16703.06213300000*Tau)
	L0 += 0.00000858760 * math.Cos(2.40093704200+2914.01423580000*Tau)
	L0 += 0.00000832724 * math.Cos(4.49495753460+3340.62968040000*Tau)
	L0 += 0.00000832718 * math.Cos(2.46418591280+3340.59517300000*Tau)
	L0 += 0.00000748724 * math.Cos(3.82248399470+155.42039943000*Tau)
	L0 += 0.00000723863 * math.Cos(0.67497565801+3738.76143010000*Tau)
	L0 += 0.00000712899 * math.Cos(3.66336014790+1059.38193020000*Tau)
	L0 += 0.00000655163 * math.Cos(0.48864075176+3127.31333130000*Tau)
	L0 += 0.00000635557 * math.Cos(2.92182704270+8432.76438480000*Tau)
	L0 += 0.00000552746 * math.Cos(4.47478863020+1748.01641310000*Tau)
	L0 += 0.00000550472 * math.Cos(3.81001205410+0.98032106820*Tau)
	L0 += 0.00000472164 * math.Cos(3.62547819410+1194.44701020000*Tau)
	L0 += 0.00000425972 * math.Cos(0.55365138172+6283.07585000000*Tau)
	L0 += 0.00000415132 * math.Cos(0.49662314774+213.29909544000*Tau)
	L0 += 0.00000312141 * math.Cos(0.99853322843+6677.70173500000*Tau)
	L0 += 0.00000306552 * math.Cos(0.38052862973+6684.74797180000*Tau)
	L0 += 0.00000302377 * math.Cos(4.48618150320+3532.06069280000*Tau)
	L0 += 0.00000299396 * math.Cos(2.78323705700+6254.62666250000*Tau)
	L0 += 0.00000293199 * math.Cos(4.22131277910+20.77539549200*Tau)
	L0 += 0.00000283600 * math.Cos(5.76885494120+3149.16416060000*Tau)
	L0 += 0.00000281073 * math.Cos(5.88163372940+1349.86740970000*Tau)
	L0 += 0.00000274035 * math.Cos(0.13372501211+3340.67973700000*Tau)
	L0 += 0.00000274028 * math.Cos(0.54222141841+3340.54511640000*Tau)
	L0 += 0.00000238857 * math.Cos(5.37155471670+4136.91043350000*Tau)
	L0 += 0.00000236114 * math.Cos(5.75504515580+3333.49887970000*Tau)
	L0 += 0.00000231185 * math.Cos(1.28240685290+3870.30339180000*Tau)
	L0 += 0.00000221225 * math.Cos(3.50466672200+382.89653222000*Tau)
	L0 += 0.00000204161 * math.Cos(2.82133266180+1221.84856630000*Tau)
	L0 += 0.00000193126 * math.Cos(3.35715137750+3.59042865180*Tau)
	L0 += 0.00000188639 * math.Cos(1.49103016490+9492.14631500000*Tau)
	L0 += 0.00000179196 * math.Cos(1.00561112570+951.71840625000*Tau)
	L0 += 0.00000174068 * math.Cos(2.41360332580+553.56940284000*Tau)
	L0 += 0.00000172110 * math.Cos(0.43943041719+5486.77784320000*Tau)
	L0 += 0.00000160011 * math.Cos(3.94854735190+4562.46099300000*Tau)
	L0 += 0.00000144305 * math.Cos(1.41874193420+135.06508004000*Tau)
	L0 += 0.00000139897 * math.Cos(3.32592516160+2700.71514040000*Tau)
	L0 += 0.00000138245 * math.Cos(4.30145176910+7.11354700080*Tau)
	L0 += 0.00000130993 * math.Cos(4.04491720260+12303.06777700000*Tau)
	L0 += 0.00000128102 * math.Cos(2.20806651010+1592.59601360000*Tau)
	L0 += 0.00000128062 * math.Cos(1.80665643330+5088.62883980000*Tau)
	L0 += 0.00000116945 * math.Cos(3.12805282210+7903.07341970000*Tau)
	L0 += 0.00000113486 * math.Cos(3.70070798120+1589.07289530000*Tau)
	L0 += 0.00000110375 * math.Cos(1.05195079690+242.72860397000*Tau)
	L0 += 0.00000104541 * math.Cos(0.78535382076+8827.39026990000*Tau)
	L0 += 0.00000100090 * math.Cos(3.24343740860+11773.37681200000*Tau)

	L1 := 3340.85627470000 * math.Cos(0.00000000000+0.00000000000*Tau)
	L1 += 0.01458227051 * math.Cos(3.60426053610+3340.61242670000*Tau)
	L1 += 0.00164901343 * math.Cos(3.92631250960+6681.22485340000*Tau)
	L1 += 0.00019963338 * math.Cos(4.26594061030+10021.83728000000*Tau)
	L1 += 0.00003452399 * math.Cos(4.73210386370+3.52311834900*Tau)
	L1 += 0.00002485480 * math.Cos(4.61277567320+13362.44970700000*Tau)
	L1 += 0.00000841551 * math.Cos(4.45858256760+2281.23049650000*Tau)
	L1 += 0.00000537566 * math.Cos(5.01589727490+398.14900341000*Tau)
	L1 += 0.00000521041 * math.Cos(4.99422678180+3344.13554500000*Tau)
	L1 += 0.00000432614 * math.Cos(2.56066402860+191.44826611000*Tau)
	L1 += 0.00000429656 * math.Cos(5.31646162370+155.42039943000*Tau)
	L1 += 0.00000381747 * math.Cos(3.53881289440+796.29800682000*Tau)
	L1 += 0.00000314129 * math.Cos(4.96335266050+16703.06213300000*Tau)
	L1 += 0.00000282804 * math.Cos(3.15967518200+2544.31441990000*Tau)
	L1 += 0.00000205664 * math.Cos(4.56891455660+2146.16541650000*Tau)
	L1 += 0.00000168805 * math.Cos(1.32894813370+3337.08930840000*Tau)
	L1 += 0.00000157587 * math.Cos(4.18501035950+1751.53953140000*Tau)
	L1 += 0.00000133686 * math.Cos(2.23325104200+0.98032106820*Tau)
	L1 += 0.00000133563 * math.Cos(5.97421903930+1748.01641310000*Tau)
	L1 += 0.00000117591 * math.Cos(6.02407213860+6151.53388830000*Tau)
	L1 += 0.00000116561 * math.Cos(2.21347652540+1059.38193020000*Tau)
	L1 += 0.00000113876 * math.Cos(2.12869455090+1194.44701020000*Tau)
	L1 += 0.00000113595 * math.Cos(5.42803224320+3738.76143010000*Tau)
	L1 += 0.00000091098 * math.Cos(1.09627836590+1349.86740970000*Tau)
	L1 += 0.00000085342 * math.Cos(3.90854841010+553.56940284000*Tau)
	L1 += 0.00000083301 * math.Cos(5.29636626270+6684.74797180000*Tau)
	L1 += 0.00000080776 * math.Cos(4.42813405870+529.69096509000*Tau)
	L1 += 0.00000079531 * math.Cos(2.24864266330+8962.45534990000*Tau)
	L1 += 0.00000072946 * math.Cos(2.50189460550+951.71840625000*Tau)
	L1 += 0.00000072505 * math.Cos(5.84208163240+242.72860397000*Tau)
	L1 += 0.00000071487 * math.Cos(3.85636094440+2914.01423580000*Tau)
	L1 += 0.00000067582 * math.Cos(5.02327686470+382.89653222000*Tau)
	L1 += 0.00000065089 * math.Cos(1.01802439310+3340.59517300000*Tau)
	L1 += 0.00000065089 * math.Cos(3.04879603980+3340.62968040000*Tau)
	L1 += 0.00000061508 * math.Cos(4.15183159800+3149.16416060000*Tau)
	L1 += 0.00000056520 * math.Cos(3.88813699320+4136.91043350000*Tau)
	L1 += 0.00000048477 * math.Cos(4.87362121540+213.29909544000*Tau)
	L1 += 0.00000047613 * math.Cos(1.18238046060+3333.49887970000*Tau)
	L1 += 0.00000046584 * math.Cos(1.31452419910+3185.19202730000*Tau)
	L1 += 0.00000041343 * math.Cos(0.71385375517+1592.59601360000*Tau)
	L1 += 0.00000040272 * math.Cos(2.72542480610+7.11354700080*Tau)
	L1 += 0.00000040055 * math.Cos(5.31611875490+20043.67456000000*Tau)
	L1 += 0.00000032886 * math.Cos(5.41067411970+6283.07585000000*Tau)
	L1 += 0.00000028244 * math.Cos(0.04534124888+9492.14631500000*Tau)
	L1 += 0.00000026579 * math.Cos(3.88960724780+1221.84856630000*Tau)
	L1 += 0.00000026554 * math.Cos(5.11271747610+2700.71514040000*Tau)

	L2 := 0.00058015791 * math.Cos(2.04979463280+3340.61242670000*Tau)
	L2 += 0.00054187645 * math.Cos(0.00000000000+0.00000000000*Tau)
	L2 += 0.00013908426 * math.Cos(2.45742359890+6681.22485340000*Tau)
	L2 += 0.00002465104 * math.Cos(2.80000020930+10021.83728000000*Tau)
	L2 += 0.00000398379 * math.Cos(3.14118428290+13362.44970700000*Tau)
	L2 += 0.00000222022 * math.Cos(3.19436080020+3.52311834900*Tau)
	L2 += 0.00000120957 * math.Cos(0.54325292454+155.42039943000*Tau)
	L2 += 0.00000061517 * math.Cos(3.48529427370+16703.06213300000*Tau)
	L2 += 0.00000053638 * math.Cos(3.54191121460+3344.13554500000*Tau)
	L2 += 0.00000034268 * math.Cos(6.00188499120+2281.23049650000*Tau)
	L2 += 0.00000031665 * math.Cos(4.14015171790+191.44826611000*Tau)
	L2 += 0.00000029839 * math.Cos(1.99870679840+796.29800682000*Tau)
	L2 += 0.00000023168 * math.Cos(4.33403365930+242.72860397000*Tau)
	L2 += 0.00000021659 * math.Cos(3.44532466380+398.14900341000*Tau)
	L2 += 0.00000020370 * math.Cos(5.42191375400+553.56940284000*Tau)
	L2 += 0.00000016227 * math.Cos(0.65678953303+0.98032106820*Tau)
	L2 += 0.00000016044 * math.Cos(6.11000472440+2146.16541650000*Tau)
	L2 += 0.00000015648 * math.Cos(1.22086121940+1748.01641310000*Tau)
	L2 += 0.00000014927 * math.Cos(6.09541783560+3185.19202730000*Tau)
	L2 += 0.00000014416 * math.Cos(4.01923812100+951.71840625000*Tau)
	L2 += 0.00000014317 * math.Cos(2.61851897590+1349.86740970000*Tau)
	L2 += 0.00000013352 * math.Cos(0.60189008414+1194.44701020000*Tau)
	L2 += 0.00000011934 * math.Cos(3.86122163020+6684.74797180000*Tau)
	L2 += 0.00000011260 * math.Cos(4.71822363670+2544.31441990000*Tau)
	L2 += 0.00000010396 * math.Cos(0.25038714677+382.89653222000*Tau)
	L2 += 0.00000009468 * math.Cos(0.68170713564+1059.38193020000*Tau)
	L2 += 0.00000009229 * math.Cos(3.83209092320+20043.67456000000*Tau)
	L2 += 0.00000009005 * math.Cos(3.88271826100+3738.76143010000*Tau)
	L2 += 0.00000007501 * math.Cos(5.46498630410+1751.53953140000*Tau)
	L2 += 0.00000006859 * math.Cos(2.57522504140+3149.16416060000*Tau)
	L2 += 0.00000006681 * math.Cos(2.37843690340+4136.91043350000*Tau)
	L2 += 0.00000006497 * math.Cos(5.47773072870+1592.59601360000*Tau)
	L2 += 0.00000006311 * math.Cos(2.34104793670+3097.88382270000*Tau)

	L3 := 0.00001482423 * math.Cos(0.44434694876+3340.61242670000*Tau)
	L3 += 0.00000662095 * math.Cos(0.88469178686+6681.22485340000*Tau)
	L3 += 0.00000188268 * math.Cos(1.28799982500+10021.83728000000*Tau)
	L3 += 0.00000041474 * math.Cos(1.64850787000+13362.44970700000*Tau)
	L3 += 0.00000025994 * math.Cos(0.00000000000+0.00000000000*Tau)
	L3 += 0.00000022661 * math.Cos(2.05267665260+155.42039943000*Tau)
	L3 += 0.00000010454 * math.Cos(1.58006906380+3.52311834900*Tau)
	L3 += 0.00000008024 * math.Cos(1.99858757690+16703.06213300000*Tau)
	L3 += 0.00000004900 * math.Cos(2.82452457970+242.72860397000*Tau)
	L3 += 0.00000003782 * math.Cos(2.01914272510+3344.13554500000*Tau)
	L3 += 0.00000003176 * math.Cos(4.59144897930+3185.19202730000*Tau)
	L3 += 0.00000003134 * math.Cos(0.65044714325+553.56940284000*Tau)

	L4 := 0.00000113969 * math.Cos(3.14159265360+0.00000000000*Tau)
	L4 += 0.00000028725 * math.Cos(5.63662412040+6681.22485340000*Tau)
	L4 += 0.00000024447 * math.Cos(5.13868481450+3340.61242670000*Tau)
	L4 += 0.00000011187 * math.Cos(6.03161074430+10021.83728000000*Tau)
	L4 += 0.00000003252 * math.Cos(0.13228350651+13362.44970700000*Tau)
	L4 += 0.00000003190 * math.Cos(3.56267988300+155.42039943000*Tau)
	L4 += 0.00000000787 * math.Cos(0.49340783377+16703.06213300000*Tau)
	L4 += 0.00000000776 * math.Cos(1.31734531590+242.72860397000*Tau)

	L5 := 0.00000000868 * math.Cos(3.14159265360+0.00000000000*Tau)
	L5 += 0.00000000710 * math.Cos(4.04089996520+6681.22485340000*Tau)
	return L0 + L1*Tau + L2*Tau2 + L3*Tau3 + L4*Tau4 + L5*Tau5
}

func _GetLatitudeMars(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	B0 := 0.03197134986 * math.Cos(3.76832042430+3340.61242670000*Tau)
	B0 += 0.00298033234 * math.Cos(4.10616996240+6681.22485340000*Tau)
	B0 += 0.00289104742 * math.Cos(0.00000000000+0.00000000000*Tau)
	B0 += 0.00031365538 * math.Cos(4.44651052850+10021.83728000000*Tau)
	B0 += 0.00003484100 * math.Cos(4.78812547890+13362.44970700000*Tau)
	B0 += 0.00000443401 * math.Cos(5.02642620490+3344.13554500000*Tau)
	B0 += 0.00000442999 * math.Cos(5.65233015880+3337.08930840000*Tau)
	B0 += 0.00000399109 * math.Cos(5.13056814700+16703.06213300000*Tau)
	B0 += 0.00000292506 * math.Cos(3.79290644590+2281.23049650000*Tau)
	B0 += 0.00000181982 * math.Cos(6.13648011700+6151.53388830000*Tau)
	B0 += 0.00000163159 * math.Cos(4.26399626630+529.69096509000*Tau)
	B0 += 0.00000159678 * math.Cos(2.23194610250+1059.38193020000*Tau)
	B0 += 0.00000149297 * math.Cos(2.16501209920+5621.84292320000*Tau)
	B0 += 0.00000142686 * math.Cos(1.18215016110+3340.59517300000*Tau)
	B0 += 0.00000142685 * math.Cos(3.21292180820+3340.62968040000*Tau)
	B0 += 0.00000139323 * math.Cos(2.41796344240+8962.45534990000*Tau)

	B1 := 0.00350068845 * math.Cos(5.36847836210+3340.61242670000*Tau)
	B1 += 0.00014116030 * math.Cos(3.14159265360+0.00000000000*Tau)
	B1 += 0.00009670755 * math.Cos(5.47877786510+6681.22485340000*Tau)
	B1 += 0.00001471918 * math.Cos(3.20205766790+10021.83728000000*Tau)
	B1 += 0.00000425864 * math.Cos(3.40843812880+13362.44970700000*Tau)
	B1 += 0.00000102039 * math.Cos(0.77617286189+3337.08930840000*Tau)
	B1 += 0.00000078848 * math.Cos(3.71768293870+16703.06213300000*Tau)
	B1 += 0.00000032708 * math.Cos(3.45803723680+5621.84292320000*Tau)
	B1 += 0.00000026171 * math.Cos(2.48293558070+2281.23049650000*Tau)

	B2 := 0.00016726690 * math.Cos(0.60221392419+3340.61242670000*Tau)
	B2 += 0.00004986799 * math.Cos(3.14159265360+0.00000000000*Tau)
	B2 += 0.00000302141 * math.Cos(5.55871276020+6681.22485340000*Tau)
	B2 += 0.00000025767 * math.Cos(1.89662673500+13362.44970700000*Tau)
	B2 += 0.00000021452 * math.Cos(0.91749968618+10021.83728000000*Tau)
	B2 += 0.00000011820 * math.Cos(2.24240738700+3337.08930840000*Tau)
	B2 += 0.00000007985 * math.Cos(2.24892866610+16703.06213300000*Tau)

	B3 := 0.00000606506 * math.Cos(1.98050633530+3340.61242670000*Tau)
	B3 += 0.00000042611 * math.Cos(0.00000000000+0.00000000000*Tau)
	B3 += 0.00000013652 * math.Cos(1.79588228800+6681.22485340000*Tau)
	B3 += 0.00000002730 * math.Cos(3.45377082120+10021.83728000000*Tau)

	B4 := 0.00000013369 * math.Cos(0.00000000000+0.00000000000*Tau)
	B4 += 0.00000011334 * math.Cos(3.45724352590+3340.61242670000*Tau)
	B4 += 0.00000000744 * math.Cos(0.50445805257+6681.22485340000*Tau)

	B5 := 0.00000000000
	return B0 + B1*Tau + B2*Tau2 + B3*Tau3 + B4*Tau4 + B5*Tau5
}

func _GetRadiusVectorMars(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	R0 := 1.53033488280 * math.Cos(0.00000000000+0.00000000000*Tau)
	R0 += 0.14184953153 * math.Cos(3.47971283520+3340.61242670000*Tau)
	R0 += 0.00660776357 * math.Cos(3.81783442100+6681.22485340000*Tau)
	R0 += 0.00046179117 * math.Cos(4.15595316280+10021.83728000000*Tau)
	R0 += 0.00008109738 * math.Cos(5.55958460170+2810.92146160000*Tau)
	R0 += 0.00007485315 * math.Cos(1.77238998070+5621.84292320000*Tau)
	R0 += 0.00005523193 * math.Cos(1.36436318880+2281.23049650000*Tau)
	R0 += 0.00003825160 * math.Cos(4.49407182410+13362.44970700000*Tau)
	R0 += 0.00002484385 * math.Cos(4.92545577890+2942.46342330000*Tau)
	R0 += 0.00002306539 * math.Cos(0.09081742493+2544.31441990000*Tau)
	R0 += 0.00001999399 * math.Cos(5.36059605230+3337.08930840000*Tau)
	R0 += 0.00001960198 * math.Cos(4.74249386320+3344.13554500000*Tau)
	R0 += 0.00001167115 * math.Cos(2.11261501150+5092.15195810000*Tau)
	R0 += 0.00001102828 * math.Cos(5.00908264160+398.14900341000*Tau)
	R0 += 0.00000992252 * math.Cos(5.83862401070+6151.53388830000*Tau)
	R0 += 0.00000899077 * math.Cos(4.40790433990+529.69096509000*Tau)
	R0 += 0.00000807348 * math.Cos(2.10216647100+1059.38193020000*Tau)
	R0 += 0.00000797910 * math.Cos(3.44839026170+796.29800682000*Tau)
	R0 += 0.00000740980 * math.Cos(1.49906336890+2146.16541650000*Tau)
	R0 += 0.00000725583 * math.Cos(1.24516913470+8432.76438480000*Tau)
	R0 += 0.00000692340 * math.Cos(2.13378814790+8962.45534990000*Tau)
	R0 += 0.00000633144 * math.Cos(0.89353285018+3340.59517300000*Tau)
	R0 += 0.00000633140 * math.Cos(2.92430448170+3340.62968040000*Tau)
	R0 += 0.00000629976 * math.Cos(1.28738135860+1751.53953140000*Tau)
	R0 += 0.00000574352 * math.Cos(0.82896196337+2914.01423580000*Tau)
	R0 += 0.00000526187 * math.Cos(5.38292276230+3738.76143010000*Tau)
	R0 += 0.00000472776 * math.Cos(5.19850457870+3127.31333130000*Tau)
	R0 += 0.00000348095 * math.Cos(4.83219198910+16703.06213300000*Tau)
	R0 += 0.00000283702 * math.Cos(2.90692294910+3532.06069280000*Tau)
	R0 += 0.00000279552 * math.Cos(5.25749247550+6283.07585000000*Tau)
	R0 += 0.00000275501 * math.Cos(1.21767967780+6254.62666250000*Tau)
	R0 += 0.00000275224 * math.Cos(2.90818883830+1748.01641310000*Tau)
	R0 += 0.00000269891 * math.Cos(3.76394728620+5884.92684660000*Tau)
	R0 += 0.00000239133 * math.Cos(2.03669896240+1194.44701020000*Tau)
	R0 += 0.00000233827 * math.Cos(5.10546492530+5486.77784320000*Tau)
	R0 += 0.00000228128 * math.Cos(3.25529020620+6872.67311950000*Tau)
	R0 += 0.00000223190 * math.Cos(4.19861593780+3149.16416060000*Tau)
	R0 += 0.00000219428 * math.Cos(5.58340248780+191.44826611000*Tau)
	R0 += 0.00000208336 * math.Cos(4.84626442120+3340.67973700000*Tau)
	R0 += 0.00000208333 * math.Cos(5.25476080770+3340.54511640000*Tau)
	R0 += 0.00000186213 * math.Cos(5.69871555750+6677.70173500000*Tau)
	R0 += 0.00000182686 * math.Cos(5.08062683360+6684.74797180000*Tau)
	R0 += 0.00000178613 * math.Cos(4.18423025540+3333.49887970000*Tau)
	R0 += 0.00000175995 * math.Cos(5.95341786370+3870.30339180000*Tau)
	R0 += 0.00000163534 * math.Cos(3.79889068110+4136.91043350000*Tau)

	R1 := 0.01107433340 * math.Cos(2.03250524950+3340.61242670000*Tau)
	R1 += 0.00103175886 * math.Cos(2.37071845680+6681.22485340000*Tau)
	R1 += 0.00012877200 * math.Cos(0.00000000000+0.00000000000*Tau)
	R1 += 0.00010815880 * math.Cos(2.70888093800+10021.83728000000*Tau)
	R1 += 0.00001194550 * math.Cos(3.04702182500+13362.44970700000*Tau)
	R1 += 0.00000438579 * math.Cos(2.88835072630+2281.23049650000*Tau)
	R1 += 0.00000395698 * math.Cos(3.42324611290+3344.13554500000*Tau)
	R1 += 0.00000182572 * math.Cos(1.58428644000+2544.31441990000*Tau)
	R1 += 0.00000135850 * math.Cos(3.38507017990+16703.06213300000*Tau)
	R1 += 0.00000128362 * math.Cos(6.04343360440+3337.08930840000*Tau)
	R1 += 0.00000128204 * math.Cos(0.62991220570+1059.38193020000*Tau)
	R1 += 0.00000127068 * math.Cos(1.95389775740+796.29800682000*Tau)
	R1 += 0.00000118443 * math.Cos(2.99761345070+2146.16541650000*Tau)
	R1 += 0.00000087537 * math.Cos(3.42052758980+398.14900341000*Tau)
	R1 += 0.00000083026 * math.Cos(3.85574986650+3738.76143010000*Tau)
	R1 += 0.00000075598 * math.Cos(4.45101839350+6151.53388830000*Tau)
	R1 += 0.00000071999 * math.Cos(2.76442180680+529.69096509000*Tau)
	R1 += 0.00000066542 * math.Cos(2.54892602690+1751.53953140000*Tau)
	R1 += 0.00000066430 * math.Cos(4.40597549960+1748.01641310000*Tau)
	R1 += 0.00000057518 * math.Cos(0.54354327916+1194.44701020000*Tau)
	R1 += 0.00000054314 * math.Cos(0.67750943459+8962.45534990000*Tau)
	R1 += 0.00000051035 * math.Cos(3.72585409210+6684.74797180000*Tau)
	R1 += 0.00000049428 * math.Cos(5.72959428360+3340.59517300000*Tau)
	R1 += 0.00000049424 * math.Cos(1.47717922230+3340.62968040000*Tau)
	R1 += 0.00000048318 * math.Cos(2.58061691300+3149.16416060000*Tau)
	R1 += 0.00000047863 * math.Cos(2.28527896840+2914.01423580000*Tau)
	R1 += 0.00000038953 * math.Cos(2.31900090550+4136.91043350000*Tau)

	R2 := 0.00044242247 * math.Cos(0.47930603943+3340.61242670000*Tau)
	R2 += 0.00008138042 * math.Cos(0.86998398093+6681.22485340000*Tau)
	R2 += 0.00001274915 * math.Cos(1.22594050810+10021.83728000000*Tau)
	R2 += 0.00000187387 * math.Cos(1.57298991980+13362.44970700000*Tau)
	R2 += 0.00000052396 * math.Cos(3.14159265360+0.00000000000*Tau)
	R2 += 0.00000040744 * math.Cos(1.97080175060+3344.13554500000*Tau)
	R2 += 0.00000026616 * math.Cos(1.91665615760+16703.06213300000*Tau)
	R2 += 0.00000017825 * math.Cos(4.43499505330+2281.23049650000*Tau)
	R2 += 0.00000011713 * math.Cos(4.52510453730+3185.19202730000*Tau)
	R2 += 0.00000010209 * math.Cos(5.39143469550+1059.38193020000*Tau)
	R2 += 0.00000009950 * math.Cos(0.41870577185+796.29800682000*Tau)

	R3 := 0.00001113107 * math.Cos(5.14987350140+3340.61242670000*Tau)
	R3 += 0.00000424446 * math.Cos(5.61343766480+6681.22485340000*Tau)
	R3 += 0.00000100044 * math.Cos(5.99726827030+10021.83728000000*Tau)
	R3 += 0.00000019606 * math.Cos(0.07633062094+13362.44970700000*Tau)
	R3 += 0.00000004693 * math.Cos(3.14159265360+0.00000000000*Tau)
	R3 += 0.00000003477 * math.Cos(0.42951907576+16703.06213300000*Tau)

	R4 := 0.00000019552 * math.Cos(3.58211650470+3340.61242670000*Tau)
	R4 += 0.00000016323 * math.Cos(4.05116076920+6681.22485340000*Tau)
	R4 += 0.00000005848 * math.Cos(4.46383962090+10021.83728000000*Tau)
	R4 += 0.00000001532 * math.Cos(4.84374321620+13362.44970700000*Tau)

	R5 := 0.00000000000
	return R0 + R1*Tau + R2*Tau2 + R3*Tau3 + R4*Tau4 + R5*Tau5
}

// ComputeMars
func ComputeMars(JD float64) TStEclipticalCord {
	var (
		Tau, Tau2, Tau3, Tau4, Tau5 float64
		Result                      TStEclipticalCord
	)
	Tau = (JD - 2451545.0) / 365250.0
	Tau2 = common.Sqr(Tau)
	Tau3 = Tau * Tau2
	Tau4 = common.Sqr(Tau2)
	Tau5 = Tau2 * Tau3

	Result.L0 = _GetLongitudeMars(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.B0 = _GetLatitudeMars(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.R0 = _GetRadiusVectorMars(Tau, Tau2, Tau3, Tau4, Tau5)
	return Result
} // ComputeMars
